import greenfoot.*;
import java.util.Date;
  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Car here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Car extends SmoothMover
{
    public double MAX_SPEED = 3;
    public static final double MAX_ACCELARATION = 5;
    public static final double MAX_BREAKING = 5;
    public static final int MAX_TURN = 5;
    
    boolean checkpoint1triggered = false;
    boolean checkpoint2triggered = false;
    
    double speed = 0;
    double acceleration = 0.1;
    double breaking = 0.1;
    int turnspeed = 2;
    int playerno;
    int lapnumber=1;
    double laptime;
    double bestlap;
    Date startTime;
    
    
    Color trackcolour;
    boolean inoil = false;
    String left,right,up,down;
    
    GreenfootImage image1 = new GreenfootImage("carsml.png");
    GreenfootImage image2 = new GreenfootImage("carbreaksml.png");
    
    GreenfootSound soundSpeed1 = new GreenfootSound("loop_0.wav");
    GreenfootSound soundSpeed2 = new GreenfootSound("loop_1_0.wav");
    GreenfootSound soundSpeed3 = new GreenfootSound("loop_2_0.wav");
    GreenfootSound soundSpeed4 = new GreenfootSound("loop_3_0.wav");
    GreenfootSound soundSpeed5 = new GreenfootSound("loop_4_0.wav");
    GreenfootSound soundSpeed6 = new GreenfootSound("loop_5_0.wav");
    
    GreenfootSound soundBreak1 = new GreenfootSound("carBreak.wav");
    
    public Car (int r, int g, int b,String left, String right, String up, String down, int playerno){
        trackcolour = new Color(r,g,b);
        this.left = left;
        this.right = right;
        this.up = up;
        this.down = down;
        this.playerno = playerno;
    }
    
    public void checkMovement() {
        if (Greenfoot.isKeyDown(up) && speed < MAX_SPEED) {
            speed = speed + acceleration;
        }
        if (Greenfoot.isKeyDown(down) && !inoil && speed > -MAX_SPEED) {
            setImage(image2);
            speed = speed - breaking;
            if (!soundBreak1.isPlaying()){
                soundBreak1.play();
            }
        }
        else if (getImage() != image1){
            setImage(image1);
        }
        if (Greenfoot.isKeyDown(left)) {
            turn(-turnspeed);
        }
        if (Greenfoot.isKeyDown(right)) {
            turn(turnspeed);
        }
    }
    
    public void checkonTrack(){
        World world = getWorld();
        //System.out.println(world.getBackground().getColorAt(getX(),getY()));
        if (!world.getBackground().getColorAt(getX(),getY()).equals(trackcolour))
        {
            if (speed>0) {
                move(-1);
            }
            else {
                move(1);
            }
            speed = 0;
        }
        
        }
    public void checkInOil(){
        if (isTouching(OilSpil.class)){
            turn(Greenfoot.getRandomNumber(1)-2);
            inoil=true;
        }
        else {
            inoil = false;
        }
        }
    
    public void testForCarCollision(){
        Actor car = getOneIntersectingObject(Car.class);
        if (car !=null){
        double otherCarX = car.getX();
        double otherCarY = car.getY();
        
        double angle = Math.atan2(otherCarY - getY(), otherCarX - getX());
        if (angle > 0) {
            turn(-2);
        }
        else if (angle < 0 ){
            turn(2);
        }
    }
    }
    
    public void checkPoints() {
        CheckPoint checkpoint =(CheckPoint)getOneIntersectingObject(CheckPoint.class);
        if (checkpoint != null){
            int cbnumber = checkpoint.checkpointnumber;
            if (cbnumber == 1) {
                if (!checkpoint2triggered && !checkpoint1triggered){
                    checkpoint1triggered = true;
                    Date date = new Date();
                    startTime = date;
                }
                else if (checkpoint2triggered && checkpoint1triggered){
                    lapnumber ++;
                    checkpoint2triggered = false;
                    checkpoint1triggered = false;
                    Date enddate = new Date();
                    laptime = enddate.getTime() - startTime.getTime();
                    laptime = laptime / 1000.0;
                    if (laptime < bestlap || bestlap == 0){
                        bestlap = laptime;
                    }
                    MyWorld world = (MyWorld)getWorld();
                    world.displayLastLaptime(laptime,bestlap,playerno,lapnumber);
                }
            }
            else {
                if (!checkpoint2triggered) {
                    checkpoint2triggered = true;
                }
            }
        }
        else if (startTime != null){
            Date enddate = new Date();
            laptime = enddate.getTime() - startTime.getTime();
            laptime = laptime /1000.0;
            MyWorld world = (MyWorld)getWorld();
            world.displayLaptime(laptime,playerno);
        }
}
    
    public void inSand() {
             if (isTouching(Sand.class)) {
                 speed = 0.5;
             }
         }
    
    public void checkSpannerReward() {
        if (isTouching(Spanner.class)) {
            removeTouching(Spanner.class);
            int reward = Greenfoot.getRandomNumber(5);
            if (reward == 0){
                acceleration = acceleration + 0.02;
                getWorld().addObject(new Reward(0),getX(),getY());
            }
            else if (reward == 1) {
                breaking = breaking + 0.02;
                getWorld().addObject(new Reward(1),getX(),getY());
            }
            else if (reward == 2) {
                MAX_SPEED = MAX_SPEED + 1;
                getWorld().addObject(new Reward(2),getX(),getY());
            }
            else if (reward == 3) {
                turnspeed = turnspeed + 1;
                getWorld().addObject(new Reward(3),getX(),getY());
            }
            else if (reward == 4) {
                speed = 0;
                getWorld().addObject(new Reward(4),getX(),getY());
            }
            
        }
    }
            
    public void playSound(){
        if (speed < 0.5) {
            if (!soundSpeed1.isPlaying()){
                soundSpeed1.play();
            }
        }
        else if (speed < 1.0) {
            if (!soundSpeed2.isPlaying()){
                soundSpeed2.play();
            }
        }
        else if (speed < 1.5) {
            if (!soundSpeed3.isPlaying()){
                soundSpeed3.play();
            }
        }
        else if (speed < 2.0) {
            if (!soundSpeed4.isPlaying()){
                soundSpeed4.play();
            }
        }
        else if (speed < 2.5) {
            if (!soundSpeed5.isPlaying()){
                soundSpeed5.play();
            }
        }
        else {
            if (!soundSpeed6.isPlaying()){
                soundSpeed6.play();
        }
    }
}
        
    
    
    /**
     * Act - do whatever the Car wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkMovement();
        checkonTrack();
        checkInOil();
        move(speed);
        testForCarCollision();
        checkPoints();
        inSand();
        checkSpannerReward();
        playSound();
        // Add
        
    }
    
}
